<!doctype html>
<html lang="en">

<head>
    <meta charset="utf-8">

    <title>RHPAM DevOps Workshop</title>

    <meta name="description" content="DevOps Testing">
    <meta name="author" content="Eric D. Schabell">

    <meta name="apple-mobile-web-app-capable" content="yes" />
    <meta name="apple-mobile-web-app-status-bar-style" content="black-translucent" />

    <meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=1.0, user-scalable=no">

    <link rel="stylesheet" href="css/reveal.min.css">
    <link rel="stylesheet" href="css/theme/redhat.css" id="theme">

    <!-- For syntax highlighting -->
    <link rel="stylesheet" href="lib/css/zenburn.css">

    <!-- If the query includes 'print-pdf', include the PDF print sheet -->
    <script>
        if (window.location.search.match(/print-pdf/gi)) {
            var link = document.createElement('link');
            link.rel = 'stylesheet';
            link.type = 'text/css';
            link.href = 'css/print/pdf.css';
            document.getElementsByTagName('head')[0].appendChild(link);
        }
    </script>

    <!--[if lt IE 9]>
    <script src="lib/js/html5shiv.js"></script>
    <![endif]-->
</head>

<body>

<div class="reveal">

    <!-- Any section element inside of this container is displayed as a slide -->
    <div class="slides">
        <section>
            <h3>Lab 4 - Create a guided rule</h3>
        </section>

        <section>
            <div style="width: 1056px; height: 200px;">
                <h2>Lab goal</h2>
                <h4>To create guided rule for calculating if peer review of submitted job is needed.</h4>
            </div>
            <div style="width: 1056px; height: 600px;">
                <img style="border: 0px" src="images/rhpam-component-ruleauthoring.png">
            </div>
        </section>

        <section>
            <div style="width: 1056px; height: 150px;">
                <h2>Peer review testing rule</h2>
            </div>
            <div style="width: 1056px; height: 200px; font-size: xx-large; text-align: left">
                For our DevOps Testing process the job includes a property <i>LINES OF i</i>, we want to create
                a rule to evaluate each job submitted and trigger a peer review in our process by setting
                <i>i REVIEW NEEDED</i> to <i>TRUE</i>. This decision is based on a job having more than fifty
                lines of i.
            </div>
            <div style="width: 1056px; height: 200px; font-size: xx-large; text-align: left">
                Let's get started!
            </div>
        </section>

        <section>
            <div style="width: 1056px; height: 150px;">
                <h2>Add new guided rule asset</h2>
            </div>
            <div style="width: 1056px; height: 50px;">
                <ul>
                    <li>Open new assets view and click on <i>ADD ASSET</i> button</li>
                </ul>
            </div>
            <div style="width: 1056px; height: 500px;">
                <img src="images/image4-1.png" />
            </div>
        </section>

        <section>
            <div style="width: 1056px; height: 150px;">
                <h2>Add new guided rule</h2>
            </div>
            <div style="width: 1056px; height: 50px;">
                <ul>
                    <li>Select guided rule from list by clicking on <i>GUIDED RULE</i></li>
                </ul>
            </div>
            <div style="width: 1056px; height: 500px;">
                <img src="images/image4-2.png" />
            </div>
        </section>

        <section>
            <div style="width: 1056px; height: 170px;">
                <h2>Create guided rule</h2>
            </div>
            <div style="width: 1056px; height: 100px;">
                <ul>
                    <li>Fill in the pop-up with guided rule name <i>devops-testing-review-rule</i>
                        and click on <i>+OK</i> to create rule:</li>
                </ul>
            </div>
            <div style="width: 1056px; height: 500px;">
                <img src="images/image4-3.png" />
            </div>
        </section>

        <section>
            <div style="width: 1056px; height: 150px;">
                <h2>Creating guided rule</h2>
            </div>
            <div style="width: 1056px; height: 150px; text-align: left">
                <ul>
                    <li>The guided rule editor is now open before you</li>
                    <li>Note the green `+` signs on the right, these open lists of options</li>
                    <li>Switch tabs by clicking on <i>Data Objects</i> tab</li>
                </ul>
            </div>
            <div style="width: 1056px; height: 500px; text-align: center">
                    <img src="images/image4-4.png" />
            </div>
        </section>

        <section>
            <div style="width: 1056px; height: 150px;">
                <h2>Creating guided rule</h2>
            </div>
            <div style="width: 1056px; height: 600px;">
                <ul>
                    <li>This view is of the available date model objects for use in this guided rule</li>
                    <img src="images/image4-5.png" />
                    <li>The <i>JOB</i> object is automatically added, if you have others you can import using <i>+New Item</i></li>
                    <li>Return to <i>Model</i> tab to start designing guided rule</li>
                </ul>
            </div>
        </section>

        <section>
            <div style="width: 1056px; height: 150px;">
                <h2>Creating guided rule</h2>
            </div>
            <div style="width: 1056px; height: 100px;">
                <ul>
                    <li>Top right green `+` is for the WHEN (condition) section of our rule</li>
                    <li>Click on this top right green `+` to open pop-up for adding a condition:</li>
                </ul>
            </div>
            <div style="width: 1056px; height: 450px;">
                <img src="images/image4-6.png" />
            </div>
        </section>

        <section>
            <div style="width: 1056px; height: 120px;">
                <h2>Creating guided rule</h2>
            </div>
            <div style="width: 1056px; height: 170px;">
                <ul>
                    <li>The condition (WHEN) need is:</li>
                    <ul>
                        <li>There is a <i>Job</i></li>
                        <li>Assign a variable name <i>$job</i> to <i>Job</i></li>
                    </ul>
                    <li>Start by selecting <i>Job</i> from menu and click on <i>+OK</i></li>
                </ul>
            </div>
            <div style="width: 1056px; height: 430px;">
                <img src="images/image4-7.png" />
            </div>
        </section>

        <section>
            <div style="width: 1056px; height: 170px;">
                <h2>Creating guided rule</h2>
            </div>
            <div style="width: 1056px; height: 80px;">
                <ul>
                    <li>The condition has now been added to the WHEN section:</li>
                </ul>
            </div>
            <div style="width: 1056px; height: 600px;">
                <img src="images/image4-8.png" />
            </div>
        </section>

        <section>
            <div style="width: 1056px; height: 120px;">
                <h2>Creating guided rule</h2>
            </div>
            <div style="width: 1056px; height: 100px;">
                <ul>
                    <li>To assign variable name <i>$job</i> click on word <i>Job</i> for pop-up</li>
                    <li>Fill in <i>Variable name</i> as shown and click on <i>Set</i> button:</li>
                </ul>
            </div>
            <div style="width: 1056px; height: 600px;">
                <img src="images/image4-9.png" />
            </div>
        </section>

        <section>
            <div style="width: 1056px; height: 120px;">
                <h2>Creating guided rule</h2>
            </div>
            <div style="width: 1056px; height: 170px;">
                <ul>
                    <li>The condition (WHEN) must measure the lines of code being greater than 50</li>
                    <li>Add constraint by clicking on <i>Job</i> for pop-up</li>
                    <li>Select <i>linesOfCode</i> from top drop down menu to add the field</li>
                </ul>
            </div>
            <div style="width: 1056px; height: 300px;">
                <img src="images/image4-10.png" />
                <img src="images/image4-11.png" />
            </div>
        </section>

        <section>
            <div style="width: 1056px; height: 120px;">
                <h2>Creating guided rule</h2>
            </div>
            <div style="width: 1056px; height: 170px;">
                <ul>
                    <li>Click on drop down menu and select <i>greater than</i></li>
                    <li>Now we're measuring how <i>linesOfCode</i> property is greater than some number</li>
                    <li>Let's add a determining value to measure for greater than</li>
                </ul>
            </div>
            <div style="width: 1056px; height: 300px;">
                <img src="images/image4-12.png" />
                <img src="images/image4-13.png" />
            </div>
        </section>

        <section>
            <div style="width: 1056px; height: 120px;">
                <h2>Creating guided rule</h2>
            </div>
            <div style="width: 1056px; height: 150px;">
                <ul>
                    <li>Click on the <i>pencil icon</i> to open pop-up</li>
                    <li>Click on <i>Literal value</i> to add box with value <i>0</i> (ZERO)</li>
                    <li>Change that value to <i>50</i></li>
                </ul>
            </div>
            <div style="width: 1056px; height: 250px;">
                <img src="images/image4-14.png" />
                <img src="images/image4-15.png" />
            </div>
        </section>

        <section>
            <div style="width: 1056px; height: 120px;">
                <h2>Don't forget to save</h2>
            </div>
            <div style="width: 1056px; height: 600px;">
                <ul>
                    <li>Click <i>SAVE</i>, add a comment, and click on <i>SAVE</i>:</li>
                    <div style="float: right">
                        <img src="images/image3-11.png" />
                    </div>
                </ul>
            </div>
        </section>

        <section>
            <div style="width: 1056px; height: 120px;">
                <h2>Creating guided rule</h2>
            </div>
            <div style="width: 1056px; height: 170px;">
                <ul>
                    <li>Let's design what happens in the THEN section if rule fires</li>
                    <li>If the lines of code is greater than fifty, peer review set to true</li>
                    <li>Click on green `+` on right of THEN (action) to open pop-up</li>
                    <li>Select <i>Change field values of $job</i> and click on <i>+OK</i> to add</li>
                </ul>
            </div>
            <div style="width: 1056px; height: 400px;">
                <img src="images/image4-16.png" />
                <img src="images/image4-17.png" />
            </div>
        </section>

        <section>
            <div style="width: 1056px; height: 150px;">
                <h2>Creating guided rule</h2>
            </div>
            <div style="width: 1056px; height: 100px;">
                <ul>
                    <li>Click on pencil icon next to <i>Set value of job</i> to open pop-up</li>
                    <li>Select <i>codeReveiwCompleted</i> from drop down menu to add field</li>
                </ul>
            </div>
            <div style="width: 1056px; height: 500px;">
                <img src="images/image4-18.png" />
                <img src="images/image4-19.png" />
            </div>
        </section>

        <section>
            <div style="width: 1056px; height: 150px;">
                <h2>Creating guided rule</h2>
            </div>
            <div style="width: 1056px; height: 80px;">
                <ul>
                    <li>Next we'll be adding a value to set for field<i>codeReviewCompleted</i></li>
                </ul>
            </div>
            <div style="width: 1056px; height: 600px;">
                <img src="images/image4-20.png" />
            </div>
        </section>

        <section>
            <div style="width: 1056px; height: 150px;">
                <h2>Creating guided rule</h2>
            </div>
            <div style="width: 1056px; height:100px;">
                <ul>
                    <li>Click on pencil icon next to <i>codeReviewCompleted</i></li>
                    <li>In pop-up, select <i>Literal value</i> to add Boolean field</li>
                </ul>
            </div>
            <div style="width: 1056px; height: 300px;">
                <img src="images/image4-21.png" />
            </div>
        </section>

        <section>
            <div style="width: 1056px; height: 150px;">
                <h2>Creating guided rule</h2>
            </div>
            <div style="width: 1056px; height:140px;">
                <ul>
                    <li>Set the value of <i>codeReviewCompleted</i> to <i>false</i></li>
                    <li>This means if false a peer review is still required for this job</li>
                    <li>This completes the <i>THEN (action)</i> section of our rule</li>
                </ul>
            </div>
            <div style="width: 1056px; height: 500px;">
                <img src="images/image4-22.png" />
            </div>
        </section>

        <section>
            <div style="width: 1056px; height: 120px;">
                <h2>Don't forget to save</h2>
            </div>
            <div style="width: 1056px; height: 600px;">
                <ul>
                    <li>Click <i>SAVE</i>, add a comment, and click on <i>SAVE</i>:</li>
                    <div style="float: right">
                        <img src="images/image3-11.png" />
                    </div>
                </ul>
            </div>
        </section>

        <section>
            <div style="width: 1056px; height: 150px;">
                <h2>Creating guided rule</h2>
            </div>
            <div style="width: 1056px; height:170px;">
                <ul>
                    <li>The last section is hidden behind <i>(show options...)</i></li>
                    <li>Click to expand, it's only got a single <i>dialect</i> attribute</li>
                    <li>Click bottom right green '+' for a pop-up to select more options</li>
                </ul>
            </div>
            <div style="width: 1056px; height: 500px;">
                <img src="images/image4-23.png" />
            </div>
        </section>

        <section>
            <div style="width: 1056px; height: 150px;">
                <h2>Creating guided rule</h2>
            </div>
            <div style="width: 1056px; height:100px;">
                <ul>
                    <li>Select <i>Attribute</i> drop down menu and add <i>no-loop</i></li>
                    <li>Click on the bottom right green '+' again to add <i>ruleflow-group</i></li>
                </ul>
            </div>
            <div style="width: 1056px; height: 300px;">
                <img src="images/image4-24.png" />
                <img src="images/image4-25.png" />
            </div>
        </section>

        <section>
            <div style="width: 1056px; height: 150px;">
                <h2>Creating guided rule</h2>
            </div>
            <div style="width: 1056px; height:150px;">
                <ul>
                    <li>The attributes are added to <i>(options)</i> section</li>
                    <li>Click in box to activate option <i>no-loop</i></li>
                    <li>Type in name of <i>ruleflow-group</i> to be <i>devopsTestingRules</i></li>
                </ul>
            </div>
            <div style="width: 1056px; height: 500px;">
                <img src="images/image4-26.png" />
            </div>
        </section>

        <section>
            <div style="width: 1056px; height: 120px;">
                <h2>Don't forget to save</h2>
            </div>
            <div style="width: 1056px; height: 600px;">
                <ul>
                    <li>Click <i>SAVE</i>, add a comment, and click on <i>SAVE</i>:</li>
                    <div style="float: right">
                        <img src="images/image3-11.png" />
                    </div>
                </ul>
            </div>
        </section>

        <section>
            <div style="width: 1056px; height: 200px;">
                <h2>Guided rule completed</h2>
            </div>
            <div style="width: 1056px; height: 600px;">
                <img src="images/image4-27.png" />
            </div>
        </section>

        <section>
            <div style="width: 1056px; height: 150px;">
                <h2>Lab results</h2>
                <h4>What you should see...</h4>
            </div>
            <div style="width: 1056px; height: 100px;">
                Click on <i>devops-testing</i> project (use bread crumb menu at the top) and view
                the domain model assets, this ends lab 4:
            </div>
            <div style="width: 1056px; height: 450px;">
                <img src="images/image4-28.png" />
            </div>
        </section>

        <section data-background="images/rh-images/rh-bg-grey.png" data-background-position="top">
            <div style="width: 1056px; height: 300px;" align="left">
                <h2>QUESTIONS?</h2>
            </div>
            <div style="width: 1056px; height: 100px;" align="right">
                <div style="width: 500px; height: 100px;" align="left">
                    Eric D. Schabell<br>
                    Global Technology Evangelist & Portfolio Architect Director<br>
                    <a href="http://twitter.com/ericschabell" target="_blank">@ericschabell</a><br>
                    <a href="http://schabell.org" target="_blank">http://schabell.org</a>
                </div>
            </div>
        </section>

        <section>
            <div style="width: 1056px; height: 200px; text-align: left">
                <img height="150" width="100%" src="images/references.jpg">
            </div>
            <div style="width: 1056px; height: 400px; text-align: left">
                More workshops: <br/>
                <ul style="font-size: smaller">
                    <li><a href="https://learn.katacoda.com/mfentanes/courses/rhpam-7-workshop" target="_blank">Process automation workshops (by MyriamJ)</a></li>
                </ul>
                <br><br>
                More reading:<br/>
                <ul style="font-size: smaller">
                    <li><a href="http://www.schabell.org/search/label/Process%20Automation%20Manager" target="_blank">Process automation blog</a></li>
                    <li><a href="http://bit.ly/effective-jboss-bpm" target="_blank">Effective business processs management with JBoss BPM (free book)</a></li>
                </ul>
                <br><br>
                More demo projects:<br/>
                <ul style="font-size: smaller">
                    <li><a href="https://gitlab.com/bpmworkshop" target="_blank">Workshop demos</a></li>
                    <li><a href="https://gitlab.com/redhatdemocentral" target="_blank">AppDev in the cloud demos</a></li>
                </ul>
            </div>
        </section>

        <section>
            <div style="width: 1056px; height: 200px;">
                <h2>Process Automation Manager</h2>
                <h3>Up next...</h3>
            </div>
            <div style="width: 1056px; height: 300px;">
                 <h3><a href="lab05.html" target="_blank">Lab 5 - Create a process</a></h3>
            </div>
        </section>
    </div>
</div>

<script src="lib/js/head.min.js"></script>
<script src="js/reveal.min.js"></script>

<script>
    // Full list of configuration options available here:
    // https://github.com/hakimel/reveal.js#configuration
    Reveal.initialize({
        controls: true,
        progress: true,
        history: true,
        center: true,

        theme: Reveal.getQueryHash().theme, // available themes are in /css/theme
        transition: Reveal.getQueryHash().transition || 'default', // default/cube/page/concave/zoom/linear/fade/none

        // Parallax scrolling
        // parallaxBackgroundImage: 'https://s3.amazonaws.com/hakim-static/reveal-js/reveal-parallax-1.jpg',
        // parallaxBackgroundSize: '2100px 900px',

        // Optional libraries used to extend on reveal.js
        dependencies: [{
            src: 'lib/js/classList.js',
            condition: function() {
                return !document.body.classList;
            }
        }, {
            src: 'plugin/markdown/marked.js',
            condition: function() {
                return !!document.querySelector('[data-markdown]');
            }
        }, {
            src: 'plugin/markdown/markdown.js',
            condition: function() {
                return !!document.querySelector('[data-markdown]');
            }
        }, {
            src: 'plugin/highlight/highlight.js',
            async: true,
            callback: function() {
                hljs.initHighlightingOnLoad();
            }
        }, {
            src: 'plugin/zoom-js/zoom.js',
            async: true,
            condition: function() {
                return !!document.body.classList;
            }
        }, {
            src: 'plugin/notes/notes.js',
            async: true,
            condition: function() {
                return !!document.body.classList;
            }
        }]
    });
</script>

</body>

</html>
